/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Sun Microsystems, Inc.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * $RCSfile: ContentProvider.idl,v $
 * $Revision: 1.14 $
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
#ifndef __com_sun_star_ucb_ContentProvider_idl__
#define __com_sun_star_ucb_ContentProvider_idl__

#ifndef __com_sun_star_ucb_XContentProvider_idl__
#include <com/sun/star/ucb/XContentProvider.idl>
#endif

#ifndef __com_sun_star_ucb_XContentIdentifierFactory_idl__
#include <com/sun/star/ucb/XContentIdentifierFactory.idl>
#endif

#ifndef __com_sun_star_ucb_XParameterizedContentProvider_idl__
#include <com/sun/star/ucb/XParameterizedContentProvider.idl>
#endif

#ifndef __com_sun_star_ucb_XContentProviderSupplier_idl__
#include <com/sun/star/ucb/XContentProviderSupplier.idl>
#endif

//=============================================================================

module com { module sun { module star { module ucb {

//=============================================================================
/** provides access to a set of <type>Content</type>s.
*/
published service ContentProvider
{
    //-------------------------------------------------------------------------
    /** gives access to all contents provided by this provider.
     */
    interface com::sun::star::ucb::XContentProvider;

    //-------------------------------------------------------------------------
    /** creates special <type>XContentIdentifier</type> implementation
        objects for the contents provided by this content provider.

        <p>This interface can be implemented in case the provider wants to
        provide some additional interfaces with its	implementation of the
        identifier objects.
     */
    [optional] interface com::sun::star::ucb::XContentIdentifierFactory;

    //-------------------------------------------------------------------------
    /** allows a <type>ContentProvider</type> to adjust itself to special
        needs.

        <p>Whenever a ContentProvider that supports this interface is
        registered at a <type>XContentProviderManager</type>, the method
        <member>XParameterizedContentProvider::registerInstance</member>
        should first be called, using the returned <type>XContentProvider</type>
        to register at the XContentProviderManager.
     */
    [optional] interface com::sun::star::ucb::XParameterizedContentProvider;

};

//=============================================================================

}; }; }; };

#endif
